using System;

namespace PuntoMedio2{
	/// <summary>
	/// /*Dada la funcin f(x)= x^3 + 2x^2+10x -20 , encontrar una raz para el inter-
	/// valo [0,2] de su dominio. Usar E=0,001 y Nmax=10.*/
	/// </summary>
	class PM{
		[STAThread]
		static void Main(){
			double a=0,b=2;
			if (PM.Continua(a,b)==1) PM.Raiz(a,b);
			else Console.Write("\nNo tiene raiz");
			Console.Read();
		}

		//Funcion para comprobar Teorema de Bolzano
		static int Continua(double a,double b){
			if(((PM.Evaluar(a)<0)&&(PM.Evaluar(b)>0))||((PM.Evaluar(a)>0)&&(PM.Evaluar(b)<0))) 
			return 1;			
			else return 0;
		}

		//Funcin Evaluar si corresponde al intervalo [0,2]
		static double Evaluar(double num){
			num=Math.Pow(num,3)+(2*(Math.Pow(num,2)))+(10*num)-20;
			return num;
		}

		//Funcin para hallar la mejor aproximacin a la Raiz
		static void Raiz(double a, double b){
			double m=0;int n=0;
			while(((Math.Abs(a-b))>=0.001)&&(n<10)){
				m=(a+b)/2;
				PM.Evaluar(m);
				if((PM.Evaluar(a)*PM.Evaluar(m))>0)a=m;
				else b=m;
				n++;
			}
			Console.Write("Busco la aproximacin "+n+" veces");
			Console.Write("\nLa raiz para el intervalo [0,2] de su dominio es: "+m);
			return;
		}
	}
}
